/**
 * *******************************************************************************
 *  Copyright (c) 2015-2022 Robert Bosch GmbH and others.
 * 
 *  This program and the accompanying materials are made
 *  available under the terms of the Eclipse Public License 2.0
 *  which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 *  SPDX-License-Identifier: EPL-2.0
 * 
 *     Generated using Eclipse EMF
 * 
 * *******************************************************************************
 */
package org.eclipse.app4mc.amalthea.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Data Rate Unit</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Data rate units (enumeration of available units)
 * <!-- end-model-doc -->
 * @see org.eclipse.app4mc.amalthea.model.AmaltheaPackage#getDataRateUnit()
 * @model
 * @generated
 */
public enum DataRateUnit implements Enumerator {
	/**
	 * The '<em><b>undefined </b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_UNDEFINED__VALUE
	 * @generated
	 * @ordered
	 */
	_UNDEFINED_(0, "_undefined_", "_undefined_"),

	/**
	 * The '<em><b>Bit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	BIT_PER_SECOND(0, "bitPerSecond", "bitPerSecond"),

	/**
	 * The '<em><b>Kbit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	KBIT_PER_SECOND(0, "kbitPerSecond", "kbitPerSecond"),

	/**
	 * The '<em><b>Mbit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	MBIT_PER_SECOND(0, "MbitPerSecond", "MbitPerSecond"),

	/**
	 * The '<em><b>Gbit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	GBIT_PER_SECOND(0, "GbitPerSecond", "GbitPerSecond"),

	/**
	 * The '<em><b>Tbit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	TBIT_PER_SECOND(0, "TbitPerSecond", "TbitPerSecond"),

	/**
	 * The '<em><b>Kibit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KIBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	KIBIT_PER_SECOND(0, "KibitPerSecond", "KibitPerSecond"),

	/**
	 * The '<em><b>Mibit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MIBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	MIBIT_PER_SECOND(0, "MibitPerSecond", "MibitPerSecond"),

	/**
	 * The '<em><b>Gibit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GIBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	GIBIT_PER_SECOND(0, "GibitPerSecond", "GibitPerSecond"),

	/**
	 * The '<em><b>Tibit Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIBIT_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	TIBIT_PER_SECOND(0, "TibitPerSecond", "TibitPerSecond"),

	/**
	 * The '<em><b>BPer Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BPER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	BPER_SECOND(0, "BPerSecond", "BPerSecond"),

	/**
	 * The '<em><b>KB Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KB_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	KB_PER_SECOND(0, "kBPerSecond", "kBPerSecond"),

	/**
	 * The '<em><b>MB Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MB_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	MB_PER_SECOND(0, "MBPerSecond", "MBPerSecond"),

	/**
	 * The '<em><b>GB Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GB_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	GB_PER_SECOND(0, "GBPerSecond", "GBPerSecond"),

	/**
	 * The '<em><b>TB Per Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TB_PER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	TB_PER_SECOND(0, "TBPerSecond", "TBPerSecond"),

	/**
	 * The '<em><b>Ki BPer Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KI_BPER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	KI_BPER_SECOND(0, "KiBPerSecond", "KiBPerSecond"),

	/**
	 * The '<em><b>Mi BPer Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MI_BPER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	MI_BPER_SECOND(0, "MiBPerSecond", "MiBPerSecond"),

	/**
	 * The '<em><b>Gi BPer Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GI_BPER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	GI_BPER_SECOND(0, "GiBPerSecond", "GiBPerSecond"),

	/**
	 * The '<em><b>Ti BPer Second</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TI_BPER_SECOND_VALUE
	 * @generated
	 * @ordered
	 */
	TI_BPER_SECOND(0, "TiBPerSecond", "TiBPerSecond");

	/**
	 * The '<em><b>undefined </b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #_UNDEFINED_
	 * @model name="_undefined_"
	 * @generated
	 * @ordered
	 */
	public static final int _UNDEFINED__VALUE = 0;

	/**
	 * The '<em><b>Bit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BIT_PER_SECOND
	 * @model name="bitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int BIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Kbit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KBIT_PER_SECOND
	 * @model name="kbitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int KBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Mbit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MBIT_PER_SECOND
	 * @model name="MbitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int MBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Gbit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GBIT_PER_SECOND
	 * @model name="GbitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int GBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Tbit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TBIT_PER_SECOND
	 * @model name="TbitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int TBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Kibit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KIBIT_PER_SECOND
	 * @model name="KibitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int KIBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Mibit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MIBIT_PER_SECOND
	 * @model name="MibitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int MIBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Gibit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GIBIT_PER_SECOND
	 * @model name="GibitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int GIBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Tibit Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIBIT_PER_SECOND
	 * @model name="TibitPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int TIBIT_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>BPer Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BPER_SECOND
	 * @model name="BPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int BPER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>KB Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KB_PER_SECOND
	 * @model name="kBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int KB_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>MB Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MB_PER_SECOND
	 * @model name="MBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int MB_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>GB Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GB_PER_SECOND
	 * @model name="GBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int GB_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>TB Per Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TB_PER_SECOND
	 * @model name="TBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int TB_PER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Ki BPer Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #KI_BPER_SECOND
	 * @model name="KiBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int KI_BPER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Mi BPer Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MI_BPER_SECOND
	 * @model name="MiBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int MI_BPER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Gi BPer Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #GI_BPER_SECOND
	 * @model name="GiBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int GI_BPER_SECOND_VALUE = 0;

	/**
	 * The '<em><b>Ti BPer Second</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TI_BPER_SECOND
	 * @model name="TiBPerSecond"
	 * @generated
	 * @ordered
	 */
	public static final int TI_BPER_SECOND_VALUE = 0;

	/**
	 * An array of all the '<em><b>Data Rate Unit</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DataRateUnit[] VALUES_ARRAY =
		new DataRateUnit[] {
			_UNDEFINED_,
			BIT_PER_SECOND,
			KBIT_PER_SECOND,
			MBIT_PER_SECOND,
			GBIT_PER_SECOND,
			TBIT_PER_SECOND,
			KIBIT_PER_SECOND,
			MIBIT_PER_SECOND,
			GIBIT_PER_SECOND,
			TIBIT_PER_SECOND,
			BPER_SECOND,
			KB_PER_SECOND,
			MB_PER_SECOND,
			GB_PER_SECOND,
			TB_PER_SECOND,
			KI_BPER_SECOND,
			MI_BPER_SECOND,
			GI_BPER_SECOND,
			TI_BPER_SECOND,
		};

	/**
	 * A public read-only list of all the '<em><b>Data Rate Unit</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<DataRateUnit> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Data Rate Unit</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataRateUnit get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataRateUnit result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Rate Unit</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataRateUnit getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataRateUnit result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Rate Unit</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static DataRateUnit get(int value) {
		switch (value) {
			case _UNDEFINED__VALUE: return _UNDEFINED_;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DataRateUnit(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //DataRateUnit
